<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd"><html xmlns="http://www.w3.org/1999/xhtml"><head><link rel="stylesheet" type="text/css" href="style.css" /><script type="text/javascript" src="highlight.js"></script></head><body><pre><span class="hs-pragma">{-# LANGUAGE DataKinds         #-}</span><span>
</span><span id="line-2"></span><span class="hs-pragma">{-# LANGUAGE DeriveAnyClass    #-}</span><span>
</span><span id="line-3"></span><span class="hs-pragma">{-# LANGUAGE DeriveFunctor     #-}</span><span>
</span><span id="line-4"></span><span class="hs-pragma">{-# LANGUAGE DeriveGeneric     #-}</span><span>
</span><span id="line-5"></span><span class="hs-pragma">{-# LANGUAGE FlexibleInstances #-}</span><span>
</span><span id="line-6"></span><span class="hs-pragma">{-# LANGUAGE OverloadedStrings #-}</span><span>
</span><span id="line-7"></span><span class="hs-pragma">{-# LANGUAGE PolyKinds         #-}</span><span>
</span><span id="line-8"></span><span class="hs-pragma">{-# LANGUAGE TypeApplications  #-}</span><span>
</span><span id="line-9"></span><span>
</span><span id="line-10"></span><span class="hs-keyword">module</span><span> </span><span class="hs-identifier">Hyperion.Bootstrap.Tiptop</span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-11"></span><span>
</span><span id="line-12"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Data.Aeson</span></span><span>           </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">FromJSON</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">ToJSON</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-13"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Aeson</span></span><span>           </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">A</span></span><span>
</span><span id="line-14"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.ByteString.Lazy</span></span><span> </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">LBS</span></span><span>
</span><span id="line-15"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Foldable</span></span><span>        </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Foldable</span></span><span>
</span><span id="line-16"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Scientific</span></span><span>      </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">S</span></span><span>
</span><span id="line-17"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Data.Vector</span></span><span>          </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">V</span></span><span>
</span><span id="line-18"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">GHC.Generics</span></span><span>         </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Generic</span></span><span class="hs-special">)</span><span>
</span><span id="line-19"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">GHC.IO.Handle</span></span><span>        </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">hClose</span></span><span class="hs-special">)</span><span>
</span><span id="line-20"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Hyperion.Log</span></span><span>         </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">Log</span></span><span>
</span><span id="line-21"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">Linear.V</span></span><span>             </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">Dim</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">V</span></span><span class="hs-special">)</span><span>
</span><span id="line-22"></span><span class="hs-keyword">import</span><span> </span><span class="hs-keyword">qualified</span><span> </span><span class="annot"><span class="hs-identifier">Linear.V</span></span><span>             </span><span class="hs-keyword">as</span><span> </span><span class="annot"><span class="hs-identifier">L</span></span><span>
</span><span id="line-23"></span><span class="hs-keyword">import</span><span>           </span><span class="annot"><span class="hs-identifier">System.Process</span></span><span>       </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier">CreateProcess</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">StdStream</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">..</span><span class="hs-special">)</span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier">proc</span></span><span class="hs-special">,</span><span>
</span><span id="line-24"></span><span>                                       </span><span class="annot"><span class="hs-identifier">withCreateProcess</span></span><span class="hs-special">)</span><span>
</span><span id="line-25"></span><span>
</span><span id="line-26"></span><span class="hs-keyword">data</span><span> </span><span id="TTV"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-var">TTV</span></a></span></span><span> </span><span id="local-6989586621679452811"><span class="annot"><a href="#local-6989586621679452811"><span class="hs-identifier hs-type">n</span></a></span></span><span> </span><span id="local-6989586621679452810"><span class="annot"><a href="#local-6989586621679452810"><span class="hs-identifier hs-type">a</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="TTV"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-var">TTV</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">V</span></span><span> </span><span class="annot"><a href="#local-6989586621679452811"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452810"><span class="hs-identifier hs-type">a</span></a></span><span class="hs-special">)</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-27"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span id="local-6989586621679452779"><span id="local-6989586621679452781"><span id="local-6989586621679452783"><span class="annot"><span class="annottext">Int -&gt; TTV n a -&gt; ShowS
[TTV n a] -&gt; ShowS
TTV n a -&gt; String
(Int -&gt; TTV n a -&gt; ShowS)
-&gt; (TTV n a -&gt; String) -&gt; ([TTV n a] -&gt; ShowS) -&gt; Show (TTV n a)
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
forall k (n :: k) a. Show a =&gt; Int -&gt; TTV n a -&gt; ShowS
forall k (n :: k) a. Show a =&gt; [TTV n a] -&gt; ShowS
forall k (n :: k) a. Show a =&gt; TTV n a -&gt; String
showList :: [TTV n a] -&gt; ShowS
$cshowList :: forall k (n :: k) a. Show a =&gt; [TTV n a] -&gt; ShowS
show :: TTV n a -&gt; String
$cshow :: forall k (n :: k) a. Show a =&gt; TTV n a -&gt; String
showsPrec :: Int -&gt; TTV n a -&gt; ShowS
$cshowsPrec :: forall k (n :: k) a. Show a =&gt; Int -&gt; TTV n a -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679452774"><span id="local-6989586621679452776"><span class="annot"><span class="annottext">a -&gt; TTV n b -&gt; TTV n a
(a -&gt; b) -&gt; TTV n a -&gt; TTV n b
(forall a b. (a -&gt; b) -&gt; TTV n a -&gt; TTV n b)
-&gt; (forall a b. a -&gt; TTV n b -&gt; TTV n a) -&gt; Functor (TTV n)
forall k (n :: k) a b. a -&gt; TTV n b -&gt; TTV n a
forall k (n :: k) a b. (a -&gt; b) -&gt; TTV n a -&gt; TTV n b
forall a b. a -&gt; TTV n b -&gt; TTV n a
forall a b. (a -&gt; b) -&gt; TTV n a -&gt; TTV n b
forall (f :: * -&gt; *).
(forall a b. (a -&gt; b) -&gt; f a -&gt; f b)
-&gt; (forall a b. a -&gt; f b -&gt; f a) -&gt; Functor f
&lt;$ :: a -&gt; TTV n b -&gt; TTV n a
$c&lt;$ :: forall k (n :: k) a b. a -&gt; TTV n b -&gt; TTV n a
fmap :: (a -&gt; b) -&gt; TTV n a -&gt; TTV n b
$cfmap :: forall k (n :: k) a b. (a -&gt; b) -&gt; TTV n a -&gt; TTV n b
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var">Functor</span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-28"></span><span>
</span><span id="line-29"></span><span id="local-6989586621679452772"><span class="hs-keyword">instance</span><span> </span><span id="local-6989586621679452765"><span id="local-6989586621679452767"><span id="local-6989586621679452769"><span class="annot"><span class="hs-identifier hs-type">Dim</span></span><span> </span><span class="annot"><a href="#local-6989586621679452772"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">ToJSON</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-type">TTV</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452772"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span class="hs-special">)</span></span></span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-30"></span><span>  </span><span id="local-6989586621679452763"><span class="annot"><span class="annottext">toJSON :: TTV n Double -&gt; Value
</span><span class="hs-identifier hs-var hs-var hs-var hs-var">toJSON</span></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-type">TTV</span></a></span><span> </span><span id="local-6989586621679452761"><span class="annot"><span class="annottext">V n Double
</span><a href="#local-6989586621679452761"><span class="hs-identifier hs-var">v</span></a></span></span><span> </span><span id="local-6989586621679452760"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679452760"><span class="hs-identifier hs-var">i</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">[Double] -&gt; Value
forall a. ToJSON a =&gt; a -&gt; Value
</span><span class="hs-identifier hs-var">toJSON</span></span><span> </span><span class="annot"><span class="annottext">([Double] -&gt; Value) -&gt; [Double] -&gt; Value
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">V n Double -&gt; [Double]
forall (t :: * -&gt; *) a. Foldable t =&gt; t a -&gt; [a]
</span><span class="hs-identifier hs-var">Foldable.toList</span></span><span> </span><span class="annot"><span class="annottext">V n Double
</span><a href="#local-6989586621679452761"><span class="hs-identifier hs-var">v</span></a></span><span> </span><span class="annot"><span class="annottext">[Double] -&gt; [Double] -&gt; [Double]
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Int -&gt; Double
forall a b. (Integral a, Num b) =&gt; a -&gt; b
</span><span class="hs-identifier hs-var">fromIntegral</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679452760"><span class="hs-identifier hs-var">i</span></a></span><span class="hs-special">]</span></span><span>
</span><span id="line-31"></span><span>
</span><span id="line-32"></span><span id="local-6989586621679452757"><span id="local-6989586621679452758"></span></span><span class="hs-keyword">data</span><span> </span><span id="Input"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#Input"><span class="hs-identifier hs-var">Input</span></a></span></span><span> </span><span id="local-6989586621679452798"><span class="annot"><a href="#local-6989586621679452798"><span class="hs-identifier hs-type">n</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="Input"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#Input"><span class="hs-identifier hs-var">Input</span></a></span></span><span>
</span><span id="line-33"></span><span>  </span><span class="hs-special">{</span><span> </span><span id="feasible"><span class="annot"><span class="annottext">Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#feasible"><span class="hs-identifier hs-var hs-var">feasible</span></a></span></span><span>    </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">V.Vector</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-type">TTV</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452798"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span class="hs-special">)</span><span>
</span><span id="line-34"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="infeasible"><span class="annot"><span class="annottext">Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#infeasible"><span class="hs-identifier hs-var hs-var">infeasible</span></a></span></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">V.Vector</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-type">TTV</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452798"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span class="hs-special">)</span><span>
</span><span id="line-35"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="in_progress"><span class="annot"><span class="annottext">Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#in_progress"><span class="hs-identifier hs-var hs-var">in_progress</span></a></span></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">V.Vector</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-type">TTV</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452798"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span class="hs-special">)</span><span>
</span><span id="line-36"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="max_gap"><span class="annot"><span class="annottext">Input n -&gt; Int
</span><a href="Hyperion.Bootstrap.Tiptop.html#max_gap"><span class="hs-identifier hs-var hs-var">max_gap</span></a></span></span><span>     </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span>
</span><span id="line-37"></span><span>  </span><span class="hs-special">,</span><span> </span><span id="resolution"><span class="annot"><span class="annottext">Input n -&gt; Double
</span><a href="Hyperion.Bootstrap.Tiptop.html#resolution"><span class="hs-identifier hs-var hs-var">resolution</span></a></span></span><span>  </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span>
</span><span id="line-38"></span><span>  </span><span class="hs-special">}</span><span> </span><span class="hs-keyword">deriving</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">(forall x. Input n -&gt; Rep (Input n) x)
-&gt; (forall x. Rep (Input n) x -&gt; Input n) -&gt; Generic (Input n)
forall x. Rep (Input n) x -&gt; Input n
forall x. Input n -&gt; Rep (Input n) x
forall a.
(forall x. a -&gt; Rep a x) -&gt; (forall x. Rep a x -&gt; a) -&gt; Generic a
forall k (n :: k) x. Rep (Input n) x -&gt; Input n
forall k (n :: k) x. Input n -&gt; Rep (Input n) x
$cto :: forall k (n :: k) x. Rep (Input n) x -&gt; Input n
$cfrom :: forall k (n :: k) x. Input n -&gt; Rep (Input n) x
</span><span class="hs-identifier hs-var hs-var hs-var hs-var">Generic</span></span><span class="hs-special">,</span><span> </span><span id="local-6989586621679452740"><span id="local-6989586621679452742"><span id="local-6989586621679452744"><span id="local-6989586621679452746"><span class="annot"><span class="annottext">[Input n] -&gt; Encoding
[Input n] -&gt; Value
Input n -&gt; Encoding
Input n -&gt; Value
(Input n -&gt; Value)
-&gt; (Input n -&gt; Encoding)
-&gt; ([Input n] -&gt; Value)
-&gt; ([Input n] -&gt; Encoding)
-&gt; ToJSON (Input n)
forall a.
(a -&gt; Value)
-&gt; (a -&gt; Encoding)
-&gt; ([a] -&gt; Value)
-&gt; ([a] -&gt; Encoding)
-&gt; ToJSON a
forall k (n :: k). Dim n =&gt; [Input n] -&gt; Encoding
forall k (n :: k). Dim n =&gt; [Input n] -&gt; Value
forall k (n :: k). Dim n =&gt; Input n -&gt; Encoding
forall k (n :: k). Dim n =&gt; Input n -&gt; Value
toEncodingList :: [Input n] -&gt; Encoding
$ctoEncodingList :: forall k (n :: k). Dim n =&gt; [Input n] -&gt; Encoding
toJSONList :: [Input n] -&gt; Value
$ctoJSONList :: forall k (n :: k). Dim n =&gt; [Input n] -&gt; Value
toEncoding :: Input n -&gt; Encoding
$ctoEncoding :: forall k (n :: k). Dim n =&gt; Input n -&gt; Encoding
toJSON :: Input n -&gt; Value
$ctoJSON :: forall k (n :: k). Dim n =&gt; Input n -&gt; Value
</span><a href="#local-6989586621679452740"><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">ToJSON</span></a></span></span></span></span></span><span class="hs-special">)</span><span>
</span><span id="line-39"></span><span>
</span><span id="line-40"></span><span class="hs-keyword">data</span><span> </span><span id="Output"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#Output"><span class="hs-identifier hs-var">Output</span></a></span></span><span> </span><span id="local-6989586621679452826"><span class="annot"><a href="#local-6989586621679452826"><span class="hs-identifier hs-type">n</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span id="NextPoint"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#NextPoint"><span class="hs-identifier hs-var">NextPoint</span></a></span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-type">TTV</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452826"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">|</span><span> </span><span id="NoPoint"><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#NoPoint"><span class="hs-identifier hs-var">NoPoint</span></a></span></span><span>
</span><span id="line-41"></span><span>  </span><span class="hs-keyword">deriving</span><span> </span><span id="local-6989586621679452732"><span id="local-6989586621679452734"><span id="local-6989586621679452736"><span class="annot"><span class="annottext">Int -&gt; Output n -&gt; ShowS
[Output n] -&gt; ShowS
Output n -&gt; String
(Int -&gt; Output n -&gt; ShowS)
-&gt; (Output n -&gt; String) -&gt; ([Output n] -&gt; ShowS) -&gt; Show (Output n)
forall a.
(Int -&gt; a -&gt; ShowS) -&gt; (a -&gt; String) -&gt; ([a] -&gt; ShowS) -&gt; Show a
forall k (n :: k). Int -&gt; Output n -&gt; ShowS
forall k (n :: k). [Output n] -&gt; ShowS
forall k (n :: k). Output n -&gt; String
showList :: [Output n] -&gt; ShowS
$cshowList :: forall k (n :: k). [Output n] -&gt; ShowS
show :: Output n -&gt; String
$cshow :: forall k (n :: k). Output n -&gt; String
showsPrec :: Int -&gt; Output n -&gt; ShowS
$cshowsPrec :: forall k (n :: k). Int -&gt; Output n -&gt; ShowS
</span><span class="hs-identifier hs-var hs-var hs-var hs-var hs-var hs-var hs-var hs-var">Show</span></span></span></span></span><span>
</span><span id="line-42"></span><span>
</span><span id="line-43"></span><span id="local-6989586621679452731"><span class="hs-keyword">instance</span><span> </span><span id="local-6989586621679452728"><span class="annot"><span class="hs-identifier hs-type">Dim</span></span><span> </span><span class="annot"><a href="#local-6989586621679452731"><span class="hs-identifier hs-type">n</span></a></span><span> </span><span class="hs-glyph">=&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">FromJSON</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#Output"><span class="hs-identifier hs-type">Output</span></a></span><span> </span><span class="annot"><a href="#local-6989586621679452731"><span class="hs-identifier hs-type">n</span></a></span><span class="hs-special">)</span></span><span> </span><span class="hs-keyword">where</span><span>
</span><span id="line-44"></span><span>  </span><span id="local-6989586621679452726"><span class="annot"><span class="annottext">parseJSON :: Value -&gt; Parser (Output n)
</span><span class="hs-identifier hs-var hs-var hs-var hs-var">parseJSON</span></span></span><span> </span><span id="local-6989586621679452724"><span class="annot"><span class="annottext">Value
</span><a href="#local-6989586621679452724"><span class="hs-identifier hs-var">val</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-45"></span><span>    </span><span id="local-6989586621679452723"><span class="annot"><span class="annottext">Vector Scientific
</span><a href="#local-6989586621679452723"><span class="hs-identifier hs-var">sciVec</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Value -&gt; Parser (Vector Scientific)
forall a. FromJSON a =&gt; Value -&gt; Parser a
</span><span class="hs-identifier hs-var">A.parseJSON</span></span><span> </span><span class="annot"><span class="annottext">Value
</span><a href="#local-6989586621679452724"><span class="hs-identifier hs-var">val</span></a></span><span>
</span><span id="line-46"></span><span>    </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Vector Scientific -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="annot"><span class="annottext">Vector Scientific
</span><a href="#local-6989586621679452723"><span class="hs-identifier hs-var">sciVec</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-47"></span><span>      </span><span class="annot"><span class="annottext">Int
</span><span class="hs-number">0</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Output n -&gt; Parser (Output n)
forall (f :: * -&gt; *) a. Applicative f =&gt; a -&gt; f a
</span><span class="hs-identifier hs-var">pure</span></span><span> </span><span class="annot"><span class="annottext">Output n
forall k (n :: k). Output n
</span><a href="Hyperion.Bootstrap.Tiptop.html#NoPoint"><span class="hs-identifier hs-var">NoPoint</span></a></span><span>
</span><span id="line-48"></span><span>      </span><span class="annot"><span class="annottext">Int
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-49"></span><span>        </span><span id="local-6989586621679452721"><span class="annot"><span class="annottext">V n Double
</span><a href="#local-6989586621679452721"><span class="hs-identifier hs-var">v</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">(Scientific -&gt; Double) -&gt; V n Scientific -&gt; V n Double
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-identifier hs-var">fmap</span></span><span> </span><span class="annot"><span class="annottext">Scientific -&gt; Double
forall a. RealFloat a =&gt; Scientific -&gt; a
</span><span class="hs-identifier hs-var">S.toRealFloat</span></span><span> </span><span class="annot"><span class="annottext">(V n Scientific -&gt; V n Double)
-&gt; Parser (V n Scientific) -&gt; Parser (V n Double)
forall (f :: * -&gt; *) a b. Functor f =&gt; (a -&gt; b) -&gt; f a -&gt; f b
</span><span class="hs-operator hs-var">&lt;$&gt;</span></span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Vector Scientific -&gt; Maybe (V n Scientific)
forall k (n :: k) a. Dim n =&gt; Vector a -&gt; Maybe (V n a)
</span><span class="hs-identifier hs-var">L.fromVector</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector Scientific -&gt; Vector Scientific
forall a. Vector a -&gt; Vector a
</span><span class="hs-identifier hs-var">V.init</span></span><span> </span><span class="annot"><span class="annottext">Vector Scientific
</span><a href="#local-6989586621679452723"><span class="hs-identifier hs-var">sciVec</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-50"></span><span>          </span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span id="local-6989586621679452716"><span class="annot"><span class="annottext">V n Scientific
</span><a href="#local-6989586621679452716"><span class="hs-identifier hs-var">v'</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">V n Scientific -&gt; Parser (V n Scientific)
forall (f :: * -&gt; *) a. Applicative f =&gt; a -&gt; f a
</span><span class="hs-identifier hs-var">pure</span></span><span> </span><span class="annot"><span class="annottext">V n Scientific
</span><a href="#local-6989586621679452716"><span class="hs-identifier hs-var">v'</span></a></span><span>
</span><span id="line-51"></span><span>          </span><span class="annot"><span class="annottext">Maybe (V n Scientific)
</span><span class="hs-identifier">_</span></span><span>       </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String -&gt; Parser (V n Scientific)
forall (m :: * -&gt; *) a. MonadFail m =&gt; String -&gt; m a
</span><span class="hs-identifier hs-var">fail</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Found vector of unexpected length&quot;</span></span><span>
</span><span id="line-52"></span><span>        </span><span id="local-6989586621679452715"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679452715"><span class="hs-identifier hs-var">i</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">Scientific -&gt; Either Double Int
forall r i. (RealFloat r, Integral i) =&gt; Scientific -&gt; Either r i
</span><span class="hs-identifier hs-var">S.floatingOrInteger</span></span><span> </span><span class="hs-glyph">@</span><span class="annot"><span class="hs-identifier hs-type">Double</span></span><span> </span><span class="hs-glyph">@</span><span class="annot"><span class="hs-identifier hs-type">Int</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector Scientific -&gt; Scientific
forall a. Vector a -&gt; a
</span><span class="hs-identifier hs-var">V.last</span></span><span> </span><span class="annot"><span class="annottext">Vector Scientific
</span><a href="#local-6989586621679452723"><span class="hs-identifier hs-var">sciVec</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-53"></span><span>          </span><span class="annot"><span class="hs-identifier hs-type">Right</span></span><span> </span><span id="local-6989586621679452712"><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679452712"><span class="hs-identifier hs-var">i'</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Int -&gt; Parser Int
forall (f :: * -&gt; *) a. Applicative f =&gt; a -&gt; f a
</span><span class="hs-identifier hs-var">pure</span></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679452712"><span class="hs-identifier hs-var">i'</span></a></span><span>
</span><span id="line-54"></span><span>          </span><span class="annot"><span class="annottext">Either Double Int
</span><span class="hs-identifier">_</span></span><span>        </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String -&gt; Parser Int
forall (m :: * -&gt; *) a. MonadFail m =&gt; String -&gt; m a
</span><span class="hs-identifier hs-var">fail</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Expected an integer but found a double&quot;</span></span><span>
</span><span id="line-55"></span><span>        </span><span class="annot"><span class="annottext">Output n -&gt; Parser (Output n)
forall (f :: * -&gt; *) a. Applicative f =&gt; a -&gt; f a
</span><span class="hs-identifier hs-var">pure</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">TTV n Double -&gt; Output n
forall k (n :: k). TTV n Double -&gt; Output n
</span><a href="Hyperion.Bootstrap.Tiptop.html#NextPoint"><span class="hs-identifier hs-var">NextPoint</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">V n Double -&gt; Int -&gt; TTV n Double
forall k (n :: k) a. V n a -&gt; Int -&gt; TTV n a
</span><a href="Hyperion.Bootstrap.Tiptop.html#TTV"><span class="hs-identifier hs-var">TTV</span></a></span><span> </span><span class="annot"><span class="annottext">V n Double
</span><a href="#local-6989586621679452721"><span class="hs-identifier hs-var">v</span></a></span><span> </span><span class="annot"><span class="annottext">Int
</span><a href="#local-6989586621679452715"><span class="hs-identifier hs-var">i</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span></span><span>
</span><span id="line-56"></span><span>
</span><span id="line-57"></span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#tiptop"><span class="hs-identifier hs-type">tiptop</span></a></span><span> </span><span class="hs-glyph">::</span><span> </span><span class="annot"><span class="hs-identifier hs-type">FilePath</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#Input"><span class="hs-identifier hs-type">Input</span></a></span><span> </span><span class="annot"><span class="hs-number">3</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="hs-identifier hs-type">IO</span></span><span> </span><span class="hs-special">(</span><span class="annot"><a href="Hyperion.Bootstrap.Tiptop.html#Output"><span class="hs-identifier hs-type">Output</span></a></span><span> </span><span class="annot"><span class="hs-number">3</span></span><span class="hs-special">)</span><span>
</span><span id="line-58"></span><span id="tiptop"><span class="annot"><span class="annottext">tiptop :: String -&gt; Input 3 -&gt; IO (Output 3)
</span><a href="Hyperion.Bootstrap.Tiptop.html#tiptop"><span class="hs-identifier hs-var hs-var">tiptop</span></a></span></span><span> </span><span id="local-6989586621679452709"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679452709"><span class="hs-identifier hs-var">tiptopExecutable</span></a></span></span><span> </span><span id="local-6989586621679452708"><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span></span><span> </span><span class="hs-glyph">=</span><span>
</span><span id="line-59"></span><span>  </span><span class="annot"><span class="annottext">CreateProcess
-&gt; (Maybe Handle
    -&gt; Maybe Handle -&gt; Maybe Handle -&gt; ProcessHandle -&gt; IO (Output 3))
-&gt; IO (Output 3)
forall a.
CreateProcess
-&gt; (Maybe Handle
    -&gt; Maybe Handle -&gt; Maybe Handle -&gt; ProcessHandle -&gt; IO a)
-&gt; IO a
</span><span class="hs-identifier hs-var">withCreateProcess</span></span><span> </span><span class="annot"><span class="annottext">CreateProcess
</span><a href="#local-6989586621679452707"><span class="hs-identifier hs-var">tiptopProc</span></a></span><span> </span><span class="annot"><span class="annottext">((Maybe Handle
  -&gt; Maybe Handle -&gt; Maybe Handle -&gt; ProcessHandle -&gt; IO (Output 3))
 -&gt; IO (Output 3))
-&gt; (Maybe Handle
    -&gt; Maybe Handle -&gt; Maybe Handle -&gt; ProcessHandle -&gt; IO (Output 3))
-&gt; IO (Output 3)
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="hs-glyph">\</span><span id="local-6989586621679452706"><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679452706"><span class="hs-identifier hs-var">stdin</span></a></span></span><span> </span><span id="local-6989586621679452705"><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679452705"><span class="hs-identifier hs-var">stdout</span></a></span></span><span> </span><span class="annot"><span class="annottext">Maybe Handle
</span><span class="hs-identifier">_</span></span><span> </span><span class="annot"><span class="annottext">ProcessHandle
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span>
</span><span id="line-60"></span><span>    </span><span class="hs-keyword">case</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679452706"><span class="hs-identifier hs-var">stdin</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Maybe Handle
</span><a href="#local-6989586621679452705"><span class="hs-identifier hs-var">stdout</span></a></span><span class="hs-special">)</span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-61"></span><span>      </span><span class="hs-special">(</span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span id="local-6989586621679452704"><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679452704"><span class="hs-identifier hs-var">hin</span></a></span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="hs-identifier hs-type">Just</span></span><span> </span><span id="local-6989586621679452703"><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679452703"><span class="hs-identifier hs-var">hout</span></a></span></span><span class="hs-special">)</span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="hs-keyword">do</span><span>
</span><span id="line-62"></span><span>        </span><span class="hs-keyword">let</span><span> </span><span id="local-6989586621679452702"><span class="annot"><span class="annottext">inString :: ByteString
</span><a href="#local-6989586621679452702"><span class="hs-identifier hs-var hs-var">inString</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">Input 3 -&gt; ByteString
forall a. ToJSON a =&gt; a -&gt; ByteString
</span><span class="hs-identifier hs-var">A.encode</span></span><span> </span><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span><span>
</span><span id="line-63"></span><span>        </span><span class="annot"><span class="annottext">Text -&gt; ByteString -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;toptop input&quot;</span></span><span> </span><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679452702"><span class="hs-identifier hs-var">inString</span></a></span><span>
</span><span id="line-64"></span><span>        </span><span class="annot"><span class="annottext">Text -&gt; Int -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;feasible points&quot;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector (TTV 3 Double) -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
forall k (n :: k). Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#feasible"><span class="hs-identifier hs-var hs-var">feasible</span></a></span><span> </span><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-65"></span><span>        </span><span class="annot"><span class="annottext">Text -&gt; Int -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;infeasible points&quot;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector (TTV 3 Double) -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
forall k (n :: k). Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#infeasible"><span class="hs-identifier hs-var hs-var">infeasible</span></a></span><span> </span><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-66"></span><span>        </span><span class="annot"><span class="annottext">Text -&gt; Int -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;in_progress points&quot;</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Vector (TTV 3 Double) -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
forall k (n :: k). Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#in_progress"><span class="hs-identifier hs-var hs-var">in_progress</span></a></span><span> </span><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span>
</span><span id="line-67"></span><span>        </span><span class="annot"><span class="annottext">Text -&gt; Int -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;total points&quot;</span></span><span> </span><span class="annot"><span class="annottext">(Int -&gt; IO ()) -&gt; Int -&gt; IO ()
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">[Int] -&gt; Int
forall (t :: * -&gt; *) a. (Foldable t, Num a) =&gt; t a -&gt; a
</span><span class="hs-identifier hs-var">sum</span></span><span> </span><span class="annot"><span class="annottext">([Int] -&gt; Int) -&gt; [Int] -&gt; Int
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">((Input 3 -&gt; Vector (TTV 3 Double)) -&gt; Int)
-&gt; [Input 3 -&gt; Vector (TTV 3 Double)] -&gt; [Int]
forall a b. (a -&gt; b) -&gt; [a] -&gt; [b]
</span><span class="hs-identifier hs-var">map</span></span><span> </span><span class="hs-special">(</span><span class="hs-glyph">\</span><span id="local-6989586621679452698"><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
</span><a href="#local-6989586621679452698"><span class="hs-identifier hs-var">f</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Vector (TTV 3 Double) -&gt; Int
forall a. Vector a -&gt; Int
</span><span class="hs-identifier hs-var">V.length</span></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
</span><a href="#local-6989586621679452698"><span class="hs-identifier hs-var">f</span></a></span><span> </span><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span><span class="hs-special">)</span><span class="hs-special">)</span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
forall k (n :: k). Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#feasible"><span class="hs-identifier hs-var hs-var">feasible</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
forall k (n :: k). Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#infeasible"><span class="hs-identifier hs-var hs-var">infeasible</span></a></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">Input 3 -&gt; Vector (TTV 3 Double)
forall k (n :: k). Input n -&gt; Vector (TTV n Double)
</span><a href="Hyperion.Bootstrap.Tiptop.html#in_progress"><span class="hs-identifier hs-var hs-var">in_progress</span></a></span><span class="hs-special">]</span><span>
</span><span id="line-68"></span><span>        </span><span class="annot"><span class="annottext">Handle -&gt; ByteString -&gt; IO ()
</span><span class="hs-identifier hs-var">LBS.hPut</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679452704"><span class="hs-identifier hs-var">hin</span></a></span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">Input 3 -&gt; ByteString
forall a. ToJSON a =&gt; a -&gt; ByteString
</span><span class="hs-identifier hs-var">A.encode</span></span><span> </span><span class="annot"><span class="annottext">Input 3
</span><a href="#local-6989586621679452708"><span class="hs-identifier hs-var">input</span></a></span><span class="hs-special">)</span><span>
</span><span id="line-69"></span><span>        </span><span class="annot"><span class="annottext">Handle -&gt; IO ()
</span><span class="hs-identifier hs-var">hClose</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679452704"><span class="hs-identifier hs-var">hin</span></a></span><span>
</span><span id="line-70"></span><span>        </span><span id="local-6989586621679452696"><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679452696"><span class="hs-identifier hs-var">out</span></a></span></span><span> </span><span class="hs-glyph">&lt;-</span><span> </span><span class="annot"><span class="annottext">Handle -&gt; IO ByteString
</span><span class="hs-identifier hs-var">LBS.hGetContents</span></span><span> </span><span class="annot"><span class="annottext">Handle
</span><a href="#local-6989586621679452703"><span class="hs-identifier hs-var">hout</span></a></span><span>
</span><span id="line-71"></span><span>        </span><span class="annot"><span class="annottext">Text -&gt; ByteString -&gt; IO ()
forall a (m :: * -&gt; *). (Show a, MonadIO m) =&gt; Text -&gt; a -&gt; m ()
</span><span class="hs-identifier hs-var">Log.info</span></span><span> </span><span class="annot"><span class="annottext">Text
</span><span class="hs-string">&quot;tiptop output&quot;</span></span><span> </span><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679452696"><span class="hs-identifier hs-var">out</span></a></span><span>
</span><span id="line-72"></span><span>        </span><span class="hs-keyword">case</span><span> </span><span class="annot"><span class="annottext">ByteString -&gt; Either String (Output 3)
forall a. FromJSON a =&gt; ByteString -&gt; Either String a
</span><span class="hs-identifier hs-var">A.eitherDecode</span></span><span> </span><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679452696"><span class="hs-identifier hs-var">out</span></a></span><span> </span><span class="hs-keyword">of</span><span>
</span><span id="line-73"></span><span>          </span><span class="annot"><span class="hs-identifier hs-type">Right</span></span><span> </span><span id="local-6989586621679452693"><span class="annot"><span class="annottext">Output 3
</span><a href="#local-6989586621679452693"><span class="hs-identifier hs-var">r</span></a></span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">Output 3 -&gt; IO (Output 3)
forall (m :: * -&gt; *) a. Monad m =&gt; a -&gt; m a
</span><span class="hs-identifier hs-var">return</span></span><span> </span><span class="annot"><span class="annottext">Output 3
</span><a href="#local-6989586621679452693"><span class="hs-identifier hs-var">r</span></a></span><span>
</span><span id="line-74"></span><span>          </span><span class="annot"><span class="hs-identifier hs-type">Left</span></span><span> </span><span id="local-6989586621679452692"><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679452692"><span class="hs-identifier hs-var">e</span></a></span></span><span>  </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String -&gt; IO (Output 3)
forall (m :: * -&gt; *) a. MonadIO m =&gt; String -&gt; m a
</span><span class="hs-identifier hs-var">Log.throwError</span></span><span> </span><span class="annot"><span class="annottext">(String -&gt; IO (Output 3)) -&gt; String -&gt; IO (Output 3)
forall a b. (a -&gt; b) -&gt; a -&gt; b
</span><span class="hs-operator hs-var">$</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Could not parse tiptop output: &quot;</span></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679452692"><span class="hs-identifier hs-var">e</span></a></span><span> </span><span class="annot"><span class="annottext">String -&gt; ShowS
forall a. [a] -&gt; [a] -&gt; [a]
</span><span class="hs-operator hs-var">++</span></span><span> </span><span class="annot"><span class="annottext">ByteString -&gt; String
forall a. Show a =&gt; a -&gt; String
</span><span class="hs-identifier hs-var">show</span></span><span> </span><span class="annot"><span class="annottext">ByteString
</span><a href="#local-6989586621679452696"><span class="hs-identifier hs-var">out</span></a></span><span>
</span><span id="line-75"></span><span>      </span><span class="annot"><span class="annottext">(Maybe Handle, Maybe Handle)
</span><span class="hs-identifier">_</span></span><span> </span><span class="hs-glyph">-&gt;</span><span> </span><span class="annot"><span class="annottext">String -&gt; IO (Output 3)
forall (m :: * -&gt; *) a. MonadIO m =&gt; String -&gt; m a
</span><span class="hs-identifier hs-var">Log.throwError</span></span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;Couldn't create pipe to tiptop process&quot;</span></span><span>
</span><span id="line-76"></span><span>  </span><span class="hs-keyword">where</span><span>
</span><span id="line-77"></span><span>    </span><span id="local-6989586621679452707"><span class="annot"><span class="annottext">tiptopProc :: CreateProcess
</span><a href="#local-6989586621679452707"><span class="hs-identifier hs-var hs-var">tiptopProc</span></a></span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="hs-special">(</span><span class="annot"><span class="annottext">String -&gt; [String] -&gt; CreateProcess
</span><span class="hs-identifier hs-var">proc</span></span><span> </span><span class="annot"><span class="annottext">String
</span><a href="#local-6989586621679452709"><span class="hs-identifier hs-var">tiptopExecutable</span></a></span><span> </span><span class="hs-special">[</span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;-&quot;</span></span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">String
</span><span class="hs-string">&quot;-&quot;</span></span><span class="hs-special">]</span><span class="hs-special">)</span><span>
</span><span id="line-78"></span><span>      </span><span class="hs-special">{</span><span> </span><span class="annot"><span class="annottext">std_in :: StdStream
</span><span class="hs-identifier hs-var">std_in</span></span><span>  </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">StdStream
</span><span class="hs-identifier hs-var">CreatePipe</span></span><span>
</span><span id="line-79"></span><span>      </span><span class="hs-special">,</span><span> </span><span class="annot"><span class="annottext">std_out :: StdStream
</span><span class="hs-identifier hs-var">std_out</span></span><span> </span><span class="hs-glyph">=</span><span> </span><span class="annot"><span class="annottext">StdStream
</span><span class="hs-identifier hs-var">CreatePipe</span></span><span>
</span><span id="line-80"></span><span>      </span><span class="hs-special">}</span><span>
</span><span id="line-81"></span><span>
</span><span id="line-82"></span></pre></body></html>